diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-emlsr-test.cc ns-3.43/src/wifi/test/wifi-emlsr-test.cc
--- ns-3.42/src/wifi/test/wifi-emlsr-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/wifi-emlsr-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -153,7 +142,7 @@
 EmlsrOperationsTestBase::DoSetup()
 {
     RngSeedManager::SetSeed(1);
-    RngSeedManager::SetRun(2);
+    RngSeedManager::SetRun(1);
     int64_t streamNumber = 100;
 
     Config::SetDefault("ns3::WifiMac::MpduBufferSize", UintegerValue(64));
@@ -177,6 +166,7 @@
     // MLDs are configured with three links
     SpectrumWifiPhyHelper phyHelper(3);
     phyHelper.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
+    phyHelper.SetPcapCaptureType(WifiPhyHelper::PcapCaptureType::PCAP_PER_LINK);
     phyHelper.Set(0, "ChannelSettings", StringValue("{2, 0, BAND_2_4GHZ, 0}"));
     phyHelper.Set(1, "ChannelSettings", StringValue("{36, 0, BAND_5GHZ, 0}"));
     phyHelper.Set(2, "ChannelSettings", StringValue("{1, 0, BAND_6GHZ, 0}"));
@@ -201,7 +191,7 @@
                 UintegerValue(1e6), // do not deassociate
                 "ActiveProbing",
                 BooleanValue(false));
-    mac.SetEmlsrManager("ns3::DefaultEmlsrManager",
+    mac.SetEmlsrManager("ns3::AdvancedEmlsrManager",
                         "EmlsrLinkSet",
                         AttributeContainerValue<UintegerValue>(m_linksToEnableEmlsrOn),
                         "MainPhyId",
@@ -262,8 +252,8 @@
     // phyHelper.EnablePcap("wifi-emlsr_STA", staDevices);
 
     // Assign fixed streams to random variables in use
-    streamNumber += wifi.AssignStreams(apDevice, streamNumber);
-    streamNumber += wifi.AssignStreams(staDevices, streamNumber);
+    streamNumber += WifiHelper::AssignStreams(apDevice, streamNumber);
+    streamNumber += WifiHelper::AssignStreams(staDevices, streamNumber);
 
     MobilityHelper mobility;
     Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
@@ -2397,7 +2387,8 @@
       m_countQoSframes(0),
       m_countBlockAck(0),
       m_countRtsframes(0),
-      m_genBackoffIfTxopWithoutTx(params.genBackoffIfTxopWithoutTx)
+      m_genBackoffIfTxopWithoutTx(params.genBackoffAndUseAuxPhyCca),
+      m_useAuxPhyCca(params.genBackoffAndUseAuxPhyCca)
 {
     m_nEmlsrStations = 1;
     m_nNonEmlsrStations = 0;
@@ -2430,6 +2421,7 @@
     Config::SetDefault("ns3::EmlsrManager::AuxPhyChannelWidth",
                        UintegerValue(m_auxPhyChannelWidth));
     Config::SetDefault("ns3::DefaultEmlsrManager::SwitchAuxPhy", BooleanValue(false));
+    Config::SetDefault("ns3::AdvancedEmlsrManager::UseAuxPhyCca", BooleanValue(m_useAuxPhyCca));
     Config::SetDefault("ns3::EhtConfiguration::MediumSyncDuration",
                        TimeValue(m_mediumSyncDuration));
     Config::SetDefault("ns3::EhtConfiguration::MsdMaxNTxops", UintegerValue(m_msdMaxNTxops));
@@ -2449,10 +2441,10 @@
     // configure channels of the given width
     for (auto band : {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_6GHZ})
     {
-        uint16_t bw = 20;
+        MHz_u bw = 20;
         uint8_t number = band == WIFI_PHY_BAND_5GHZ ? 36 : 1;
 
-        auto width = std::min<uint16_t>(m_channelWidth, band == WIFI_PHY_BAND_2_4GHZ ? 40 : 160);
+        auto width = std::min<MHz_u>(m_channelWidth, band == WIFI_PHY_BAND_2_4GHZ ? 40 : 160);
         while (bw < width)
         {
             bw *= 2;
@@ -2507,10 +2499,26 @@
 
     if (m_checkBackoffStarted)
     {
-        m_backoffEndTime = Simulator::Now() +
-                           m_staMacs[0]->GetChannelAccessManager(linkId)->GetSifs() +
-                           (m_staMacs[0]->GetQosTxop(AC_BE)->GetAifsn(linkId) + backoff) *
-                               m_staMacs[0]->GetChannelAccessManager(linkId)->GetSlot();
+        if (!m_backoffEndTime.has_value())
+        {
+            // this is the first time we set m_backoffEndTime, which is done right after receiving
+            // a BlockAck, thus we have to wait an AIFS before invoking backoff
+            m_backoffEndTime = Simulator::Now() +
+                               m_staMacs[0]->GetChannelAccessManager(linkId)->GetSifs() +
+                               m_staMacs[0]->GetQosTxop(AC_BE)->GetAifsn(linkId) *
+                                   m_staMacs[0]->GetChannelAccessManager(linkId)->GetSlot();
+        }
+        else
+        {
+            // we get here when the backoff expired but no transmission occurred, thus we have
+            // generated a new backoff value and we will start decrementing the counter in a slot
+            m_backoffEndTime =
+                Simulator::Now() + m_staMacs[0]->GetChannelAccessManager(linkId)->GetSlot();
+        }
+        // add the time corresponding to the generated number of slots
+        m_backoffEndTime.value() +=
+            backoff * m_staMacs[0]->GetChannelAccessManager(linkId)->GetSlot();
+        NS_LOG_DEBUG("Expected backoff end time = " << m_backoffEndTime->As(Time::US) << "\n");
     }
 }
 
@@ -2534,6 +2542,10 @@
         NS_TEST_EXPECT_MSG_EQ(+linkId, +m_mainPhyId, "AssocReq not sent by the main PHY");
         break;
 
+    case WIFI_MAC_CTL_TRIGGER:
+        CheckInitialControlFrame(*psdu->begin(), txVector, linkId);
+        break;
+
     case WIFI_MAC_CTL_RTS:
         CheckRtsFrames(*psdu->begin(), txVector, linkId);
         break;
@@ -2648,7 +2660,7 @@
                     false);
 
                 Simulator::Schedule(
-                    txDuration + MicroSeconds(1) /* propagation delay */,
+                    txDuration + MicroSeconds(MAX_PROPAGATION_DELAY_USEC),
                     [=, this]() {
                         CheckBlockedLink(
                             m_apMac,
@@ -2776,6 +2788,23 @@
     auto txDuration =
         WifiPhy::CalculateTxDuration(psduMap, txVector, m_apMac->GetWifiPhy(linkId)->GetPhyBand());
 
+    // in this test, BlockAck frames terminates TXOP. If a BlockAck frame is sent on an EMLSR link
+    // other than the main PHY link, it means that the aux PHY associated with that link is in
+    // sleep mode and it is resumed after the end of the BlockAck frame
+    if (linkId != m_mainPhyId && linkId != m_nonEmlsrLink)
+    {
+        Simulator::Schedule(txDuration - NanoSeconds(1), [=, this]() {
+            NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetDevice()->GetPhy(linkId)->IsStateSleep(),
+                                  true,
+                                  "Aux PHY on link " << +linkId << " not in sleep mode");
+        });
+        Simulator::Schedule(txDuration + NanoSeconds(1), [=, this]() {
+            NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetDevice()->GetPhy(linkId)->IsStateSleep(),
+                                  false,
+                                  "Aux PHY on link " << +linkId << " in sleep mode");
+        });
+    }
+
     switch (m_countBlockAck)
     {
     case 1:
@@ -2852,7 +2881,7 @@
         NS_LOG_INFO("Enqueuing two packets at the EMLSR client\n");
         m_staMacs[0]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 0, 2, 1000));
         break;
-    case 6:
+    case 6: {
         // block transmission on the main PHY link and on the non-EMLSR link (if any), so that
         // the next QoS frames are sent on a link where an aux PHY is operating
         std::set<uint8_t> linkIds{m_mainPhyId};
@@ -2867,6 +2896,7 @@
                                                           m_staMacs[0]->GetAddress(),
                                                           {0},
                                                           linkIds);
+    }
         // make sure aux PHYs are capable of transmitting frames
         m_staMacs[0]->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
                                               m_apMac->GetAddress(),
@@ -2875,12 +2905,146 @@
         // generate data packets for another UL data frame
         NS_LOG_INFO("Enqueuing two packets at the EMLSR client\n");
         m_staMacs[0]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 0, 2, 1000));
+        break;
+    case 7:
+        // make the aux PHY(s) not capable of transmitting frames
+        m_staMacs[0]->GetEmlsrManager()->SetAuxPhyTxCapable(false);
+        if (!m_nonEmlsrLink)
+        {
+            // if there are two non-primary links, set MediumSyncDuration to zero so that the
+            // next UL QoS data frame is not protected also in case it is transmitted on the
+            // non-primary link other than the one on which the last frame exchange occurred
+            m_staMacs[0]->GetEmlsrManager()->SetMediumSyncDuration(Seconds(0));
+        }
+
+        // generate a very large backoff for the primary link, so that when an aux PHY gains a
+        // TXOP, it requests the main PHY to switch to its link to transmit the frames
+        m_staMacs[0]->GetQosTxop(AC_BE)->StartBackoffNow(100, m_mainPhyId);
+
+        // events to be scheduled at the end of the BlockAck response
+        Simulator::Schedule(txDuration + NanoSeconds(1), [=, this]() {
+            // check that the main PHY switches to its primary link
+            auto mainPhy = m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId);
+            auto mainPhyLinkid = m_staMacs[0]->GetLinkForPhy(mainPhy);
+
+            NS_TEST_EXPECT_MSG_EQ(mainPhy->IsStateSwitching(),
+                                  true,
+                                  "Main PHY is not switching at time "
+                                      << Simulator::Now().As(Time::NS));
+            NS_TEST_ASSERT_MSG_EQ(mainPhyLinkid.has_value(),
+                                  true,
+                                  "Main PHY should be operating on a link");
+            NS_TEST_EXPECT_MSG_EQ(+mainPhyLinkid.value(),
+                                  +m_mainPhyId,
+                                  "Main PHY expected to operate on the primary link");
+
+            // events to be scheduled when the first main PHY channel switch is completed
+            Simulator::Schedule(mainPhy->GetChannelSwitchDelay(), [=, this]() {
+                auto acBe = m_staMacs[0]->GetQosTxop(AC_BE);
+
+                // find the min remaining backoff time on non-primary links for AC BE
+                auto minBackoff = Time::Max();
+                for (uint8_t id = 0; id < m_staMacs[0]->GetNLinks(); id++)
+                {
+                    // update backoff
+                    m_staMacs[0]->GetChannelAccessManager(id)->NeedBackoffUponAccess(acBe,
+                                                                                     true,
+                                                                                     true);
+                    if (auto backoff =
+                            m_staMacs[0]->GetChannelAccessManager(id)->GetBackoffEndFor(acBe);
+                        id != m_mainPhyId && m_staMacs[0]->IsEmlsrLink(id) && backoff < minBackoff)
+                    {
+                        minBackoff = backoff;
+                    }
+                }
+
+                // if the backoff on a link has expired before the end of the main PHY channel
+                // switch, the main PHY will be requested to switch again at the first slot
+                // boundary after the end of the channel switch. Otherwise, it will be requested
+                // to switch when the backoff expires.
+                auto expected2ndSwitchDelay = (minBackoff <= Simulator::Now())
+                                                  ? mainPhy->GetSlot()
+                                                  : (minBackoff - Simulator::Now());
+
+                // check that the main PHY is requested to switch to a non-primary link after
+                // the expected delay
+                Simulator::Schedule(expected2ndSwitchDelay + NanoSeconds(1), [=, this]() {
+                    NS_TEST_EXPECT_MSG_EQ(mainPhy->IsStateSwitching(),
+                                          true,
+                                          "Main PHY is not switching at time "
+                                              << Simulator::Now().As(Time::NS));
+                    NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetLinkForPhy(mainPhy).has_value(),
+                                          false,
+                                          "Main PHY should not be operating on a link because it "
+                                          "should be switching to a non-primary link");
+
+                    // events to be scheduled when main PHY finishes switching to non-primary link
+                    Simulator::Schedule(mainPhy->GetDelayUntilIdle(), [=, this]() {
+                        auto nonPrimLinkId = m_staMacs[0]->GetLinkForPhy(mainPhy);
+
+                        NS_TEST_ASSERT_MSG_EQ(nonPrimLinkId.has_value(),
+                                              true,
+                                              "Main PHY should have completed switching");
+                        // update backoff on the non-primary link on which main PHY is operating
+                        m_staMacs[0]
+                            ->GetChannelAccessManager(*nonPrimLinkId)
+                            ->NeedBackoffUponAccess(acBe, true, true);
+                        // record the time the transmission of the QoS data frames must have
+                        // started: (a PIFS after) end of channel switch, if the backoff counter
+                        // on the non-primary link is null and UseAuxPhyCca is true (false); when
+                        // the backoff expires, otherwise
+                        if (auto slots = acBe->GetBackoffSlots(*nonPrimLinkId); slots == 0)
+                        {
+                            m_5thQosFrameTxTime =
+                                Simulator::Now() + (m_useAuxPhyCca ? Time{0} : mainPhy->GetPifs());
+                        }
+                        else
+                        {
+                            m_5thQosFrameTxTime = m_staMacs[0]
+                                                      ->GetChannelAccessManager(*nonPrimLinkId)
+                                                      ->GetBackoffEndFor(acBe);
+                        }
+                    });
+                });
+            });
+        });
+
+        // generate data packets for another UL data frame
+        NS_LOG_INFO("Enqueuing two packets at the EMLSR client\n");
+        m_staMacs[0]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 0, 2, 1000));
 
         break;
     }
 }
 
 void
+EmlsrUlTxopTest::CheckInitialControlFrame(Ptr<const WifiMpdu> mpdu,
+                                          const WifiTxVector& txVector,
+                                          uint8_t linkId)
+{
+    CtrlTriggerHeader trigger;
+    mpdu->GetPacket()->PeekHeader(trigger);
+    if (!trigger.IsMuRts())
+    {
+        return;
+    }
+
+    if (linkId != m_mainPhyId && linkId != m_nonEmlsrLink)
+    {
+        // this is an ICF sent on an aux PHY link to start a DL TXOP. Given that aux PHYs do not
+        // switch channel, they are put in sleep mode while the main PHY is operating on their link
+        auto auxPhy = m_staMacs[0]->GetWifiPhy(linkId);
+        auto txDuration =
+            WifiPhy::CalculateTxDuration(mpdu->GetSize(), txVector, auxPhy->GetPhyBand());
+        Simulator::Schedule(txDuration + NanoSeconds(1), [=, this]() {
+            NS_TEST_EXPECT_MSG_EQ(auxPhy->IsStateSleep(),
+                                  true,
+                                  "Aux PHY on link " << +linkId << " not in sleep mode");
+        });
+    }
+}
+
+void
 EmlsrUlTxopTest::CheckRtsFrames(Ptr<const WifiMpdu> mpdu,
                                 const WifiTxVector& txVector,
                                 uint8_t linkId)
@@ -2923,6 +3087,42 @@
                                 const WifiTxVector& txVector,
                                 uint8_t linkId)
 {
+    if (m_firstUlPktsGenTime.IsZero())
+    {
+        // this function only considers CTS frames sent after the first QoS data frame
+        return;
+    }
+
+    auto txDuration = WifiPhy::CalculateTxDuration(mpdu->GetSize(),
+                                                   txVector,
+                                                   m_apMac->GetWifiPhy(linkId)->GetPhyBand());
+
+    if (linkId != m_mainPhyId && linkId != m_nonEmlsrLink &&
+        mpdu->GetHeader().GetAddr1() == m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress())
+    {
+        // this is a CTS sent to an aux PHY starting an UL TXOP. Given that aux PHYs do not
+        // switch channel, they are put in sleep mode when the main PHY starts operating on their
+        // link, which coincides with the end of CTS plus two propagation delays
+        auto auxPhy = m_staMacs[0]->GetWifiPhy(linkId);
+        Simulator::Schedule(txDuration, [=, this]() {
+            NS_TEST_EXPECT_MSG_EQ(auxPhy->IsStateSleep(),
+                                  false,
+                                  "Aux PHY on link " << +linkId << " already in sleep mode");
+        });
+        // if the CTS is corrupted, the TXOP ends and the aux PHY is not put to sleep
+        auto isStateSleep = !(m_corruptCts.has_value() && *m_corruptCts);
+
+        Simulator::Schedule(
+            txDuration + MicroSeconds(2 * MAX_PROPAGATION_DELAY_USEC) + NanoSeconds(1),
+            [=, this]() {
+                NS_TEST_EXPECT_MSG_EQ(auxPhy->IsStateSleep(),
+                                      isStateSleep,
+                                      "Aux PHY on link " << +linkId
+                                                         << (isStateSleep ? " not yet" : " already")
+                                                         << " in sleep mode");
+            });
+    }
+
     if (m_corruptCts.has_value() && *m_corruptCts)
     {
         // corrupt reception at EMLSR client
@@ -2930,9 +3130,6 @@
         m_errorModel->SetList({mpdu->GetPacket()->GetUid()});
         m_corruptCts = false;
 
-        auto txDuration = WifiPhy::CalculateTxDuration(mpdu->GetSize(),
-                                                       txVector,
-                                                       m_apMac->GetWifiPhy(linkId)->GetPhyBand());
         // main PHY is about to complete channel switch when CTS ends
         Simulator::Schedule(txDuration, [=, this]() {
             const auto mainPhy = m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId);
@@ -2961,7 +3158,7 @@
     {
         NS_TEST_EXPECT_MSG_LT_OR_EQ(
             m_countRtsframes,
-            m_msdMaxNTxops,
+            +m_msdMaxNTxops,
             "Unexpected number of RTS frames sent while the MediumSyncDelay timer is running");
     }
 
@@ -3046,15 +3243,19 @@
      *            └───┴───┘
      *
      * For both scenarios, after the last frame exchange on the main PHY link, we have the
-     * following frame exchange on an EMLSR link where an aux PHY is operating on:
+     * following frame exchanges on an EMLSR link where an aux PHY is operating on. After the
+     * first frame exchange, aux PHYs are configured as non-TX capable. Note that the two frame
+     * exchanges may occur on distinct non-primary EMLSR links.
      *
-     *             ┌───┐              ┌───┐         ┌──┐
-     *             │CTS│              │CTS│         │BA│
-     *  ──────┬───┬┴───X─────────┬───┬┴───┴┬───┬───┬┴──┴─────────────────────────────────────
-     *        │RTS│              │RTS│     │QoS│QoS│
-     *        └───┘              └───┘     │ X │ Y │
-     *                                     └───┴───┘
-     * For all EMLSR links scenario, X=10, Y=11; otherwise, X=12, Y=13.
+     *                                             | main PHY || main PHY  |
+     *  [ link ]   ┌───┐         ┌───┐         ┌──┐| switches ||switches to|             ┌──┐
+     *  [0 or 2]   │CTS│         │CTS│         │BA│|to primary||non-primary|PIFS|        │BA│
+     *  ──────┬───┬┴───X────┬───┬┴───┴┬───┬───┬┴──┴─────────────────────────────┬───┬───┬┴──┴────
+     *        │RTS│         │RTS│     │QoS│QoS│                                 │QoS│QoS│
+     *        └───┘         └───┘     │ X │ Y │                                 │ Z │ W │
+     *                                └───┴───┘                                 └───┴───┘
+     * For all EMLSR links scenario, X=10, Y=11, Z=12, W=13
+     * For the scenario with a non-EMLSR link, X=12, Y=13, Z=14, W=15
      */
 
     // jump to the first (non-Beacon) frame transmitted after establishing BA agreements and
@@ -3161,15 +3362,15 @@
 
             NS_TEST_EXPECT_MSG_EQ(+psduIt->phyId,
                                   +m_mainPhyId,
-                                  "Last QoS data frame should be transmitted by the main PHY");
+                                  "Third QoS data frame should be transmitted by the main PHY");
             NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
                                   m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId)->GetChannelWidth(),
-                                  "Expecting TX width of last data frame to equal the channel "
+                                  "Expecting TX width of third data frame to equal the channel "
                                   "width used by the main PHY");
             NS_TEST_EXPECT_MSG_GT_OR_EQ(
                 psduIt->startTx,
                 m_lastMsdExpiryTime,
-                "Last QoS data frame sent before MediumSyncDelay timer expired");
+                "Third QoS data frame sent before MediumSyncDelay timer expired");
 
             break;
         }
@@ -3177,88 +3378,122 @@
 
     NS_TEST_EXPECT_MSG_EQ(moreQosDataFound,
                           true,
-                          "Last QoS data frame transmitted by the main PHY not found");
+                          "Third QoS data frame transmitted by the main PHY not found");
 
     NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()), true, "Expected more frames");
     ++psduIt;
     jumpToQosDataOrMuRts();
 
-    // the first attempt at transmitting the last QoS data frame fails because CTS is corrupted
+    // the first attempt at transmitting the fourth QoS data frame fails because CTS is corrupted
     // RTS
     NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
                           true,
-                          "RTS before last QoS data frame has not been transmitted");
+                          "RTS before fourth QoS data frame has not been transmitted");
     NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsRts(),
                           true,
-                          "Last QoS data frame should be transmitted with protection");
+                          "Fourth QoS data frame should be transmitted with protection");
     NS_TEST_EXPECT_MSG_NE(
         +psduIt->phyId,
         +m_mainPhyId,
-        "RTS before last QoS data frame should not be transmitted by the main PHY");
+        "RTS before fourth QoS data frame should not be transmitted by the main PHY");
     NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
                           m_auxPhyChannelWidth,
-                          "RTS before last data frame transmitted on an unexpected width");
+                          "RTS before fourth data frame transmitted on an unexpected width");
     psduIt++;
     // CTS
     NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
                           true,
-                          "CTS before last QoS data frame has not been transmitted");
+                          "CTS before fourth QoS data frame has not been transmitted");
     NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsCts(),
                           true,
-                          "CTS before last QoS data frame has not been transmitted");
+                          "CTS before fourth QoS data frame has not been transmitted");
     psduIt++;
     jumpToQosDataOrMuRts();
 
-    // the last QoS data frame is transmitted by an aux PHY after that the aux PHY has
+    // the fourth QoS data frame is transmitted by an aux PHY after that the aux PHY has
     // obtained a TXOP and sent an RTS
     // RTS
     NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
                           true,
-                          "RTS before last QoS data frame has not been transmitted");
+                          "RTS before fourth QoS data frame has not been transmitted");
     NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsRts(),
                           true,
-                          "Last QoS data frame should be transmitted with protection");
+                          "Fourth QoS data frame should be transmitted with protection");
     NS_TEST_EXPECT_MSG_NE(
         +psduIt->phyId,
         +m_mainPhyId,
-        "RTS before last QoS data frame should not be transmitted by the main PHY");
+        "RTS before fourth QoS data frame should not be transmitted by the main PHY");
     NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
                           m_auxPhyChannelWidth,
-                          "RTS before last data frame transmitted on an unexpected width");
+                          "RTS before fourth data frame transmitted on an unexpected width");
     psduIt++;
     // CTS
     NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
                           true,
-                          "CTS before last QoS data frame has not been transmitted");
+                          "CTS before fourth QoS data frame has not been transmitted");
     NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsCts(),
                           true,
-                          "CTS before last QoS data frame has not been transmitted");
+                          "CTS before fourth QoS data frame has not been transmitted");
     psduIt++;
     // QoS Data
     NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
                           true,
-                          "Last QoS data frame has not been transmitted");
+                          "Fourth QoS data frame has not been transmitted");
     NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsQosData(),
                           true,
-                          "Last QoS data frame has not been transmitted");
+                          "Fourth QoS data frame has not been transmitted");
     NS_TEST_EXPECT_MSG_EQ(+psduIt->phyId,
                           +m_mainPhyId,
-                          "Last QoS data frame should be transmitted by the main PHY");
+                          "Fourth QoS data frame should be transmitted by the main PHY");
     NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
                           m_auxPhyChannelWidth,
-                          "Last data frame not transmitted on the same width as RTS");
+                          "Fourth data frame not transmitted on the same width as RTS");
+
+    psduIt++;
+    jumpToQosDataOrMuRts();
+
+    // the fifth QoS data frame is transmitted by the main PHY on a non-primary link because
+    // the aux PHY is not TX capable. The QoS data frame is not protected by RTS
+    // QoS Data
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "Fifth QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsQosData(),
+                          true,
+                          "Fifth QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(+psduIt->phyId,
+                          +m_mainPhyId,
+                          "Fifth QoS data frame should be transmitted by the main PHY");
+    NS_TEST_EXPECT_MSG_NE(+psduIt->linkId,
+                          +m_mainPhyId,
+                          "Fifth QoS data frame should be transmitted on a non-primary link");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
+                          (m_useAuxPhyCca ? m_auxPhyChannelWidth : m_channelWidth),
+                          "Fifth data frame not transmitted on the correct channel width");
+    // Do not check the start transmission time if a backoff is generated even when no
+    // transmission is done (if the backoff expires while the main PHY is switching, a new
+    // backoff is generated and, before this backoff expires, the main PHY may be requested
+    // to switch to another non-primary link; this may happen multiple times...)
+    if (!m_genBackoffIfTxopWithoutTx)
+    {
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(psduIt->startTx,
+                                    m_5thQosFrameTxTime,
+                                    "Fifth data frame transmitted too late");
+    }
 }
 
 EmlsrLinkSwitchTest::EmlsrLinkSwitchTest(const Params& params)
-    : EmlsrOperationsTestBase(std::string("Check EMLSR link switching (switchAuxPhy=") +
-                              std::to_string(params.switchAuxPhy) +
-                              ", resetCamState=" + std::to_string(params.resetCamState) +
-                              ", auxPhyMaxChWidth=" + std::to_string(params.auxPhyMaxChWidth) +
-                              "MHz )"),
+    : EmlsrOperationsTestBase(
+          std::string("Check EMLSR link switching (switchAuxPhy=") +
+          std::to_string(params.switchAuxPhy) + ", resetCamStateAndInterruptSwitch=" +
+          std::to_string(params.resetCamStateAndInterruptSwitch) +
+          ", auxPhyMaxChWidth=" + std::to_string(params.auxPhyMaxChWidth) + "MHz )"),
       m_switchAuxPhy(params.switchAuxPhy),
-      m_resetCamState(params.resetCamState),
+      m_resetCamStateAndInterruptSwitch(params.resetCamStateAndInterruptSwitch),
       m_auxPhyMaxChWidth(params.auxPhyMaxChWidth),
       m_countQoSframes(0),
+      m_countIcfFrames(0),
+      m_countRtsFrames(0),
       m_txPsdusPos(0)
 {
     m_nEmlsrStations = 1;
@@ -3269,7 +3504,7 @@
     m_duration = Seconds(1.0);
     // when aux PHYs do not switch link, the main PHY switches back to its previous link after
     // a TXOP, hence the transition delay must exceed the channel switch delay (default: 250us)
-    m_transitionDelay = {MicroSeconds(256)};
+    m_transitionDelay = {MicroSeconds(128)};
 }
 
 void
@@ -3319,12 +3554,6 @@
                                                          {0},
                                                          linksToBlock);
         }
-        else if (category == WifiActionHeader::BLOCK_ACK &&
-                 action.blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_RESPONSE)
-        {
-            // store the current number of transmitted frame
-            m_txPsdusPos = m_txPsdus.size() - 1;
-        }
     }
     break;
 
@@ -3336,6 +3565,10 @@
         CheckQosFrames(psduMap, txVector, linkId);
         break;
 
+    case WIFI_MAC_CTL_RTS:
+        CheckRtsFrame(psduMap, txVector, linkId);
+        break;
+
     default:;
     }
 }
